#ifndef _MACROS_
#define _MACROS_


//-----------------------------------------------------------------------------
//---= include =---------------------------------------------------------------
//-----------------------------------------------------------------------------
#include "includes.h"
#include "lists.h"
#include "errors.h"
#include "params.h"


//-----------------------------------------------------------------------------
//---= enum/define/typedef =---------------------------------------------------
//-----------------------------------------------------------------------------
typedef struct
{
	char	*name;		//macroname

	PARAM	*PL;		//arguments

	char	*code;		//macro code
	DWORD	size;		//number of lines in code

	DWORD	file_no;	//file_no of macro-source
	DWORD	line_cntr;	//pos of MACRO-directive

	int		pass;

} MACROLIST;

//-----------------------------------------------------------------------------
//---= class =-----------------------------------------------------------------
//-----------------------------------------------------------------------------
class MACRO
{
public:
	MACRO();
	DWORD split_args(char *, char *);
	DWORD add(char *, char *);
	DWORD process(MACROLIST *, LIST *);
	DWORD exec(char *, char *);
	MACROLIST *if_exist(char *);
	~MACRO();

private:
	LIST *MacroList;
};

//-----------------------------------------------------------------------------
//---= extern =----------------------------------------------------------------
//-----------------------------------------------------------------------------
extern MACRO macro;
#endif
