#ifndef _PARAMS_
#define _PARAMS_


//-----------------------------------------------------------------------------
//---= include =---------------------------------------------------------------
//-----------------------------------------------------------------------------
#include "includes.h"


//-----------------------------------------------------------------------------
//---= enum/define/typedef =---------------------------------------------------
//-----------------------------------------------------------------------------
#define MAX_INSTR_PARAMS 64	//max params in line

enum //used in the call param.scan
{
	PARAM_GET_STRINGS = 1,	//this bit set: return param-strings
	PARAM_GET_VALUES = 2	//this bit set: return values and intmath-errors
};

enum	//constants for parameter-type
{
	PTYPE_UNDEF,	//value not tested

	PTYPE_VALUE,	//default param-type (no lbl, no reg)
	PTYPE_REG,		//its a predefined reg (LBL_TYPE_REG, defined by REGDEF) without MATH_PROCESSING (+,*,-,/,...)
	PTYPE_LBL,		//its a data/code-label (pc-label or self-defined)

	PTYPE_STRING,	//its a string "..." (NOTE: this type is already converted into a real string)

	PTYPE_OFF,		//first param from OFF(BASE)
	PTYPE_DEFOFF,	//use prog_cntr as OFF
	PTYPE_BASE		//seccond param from OFF(BASE) (should be a LBL_TYPE_REG without MP)
};

typedef struct	//structure describing param
{
	__int8 type;	//param_type

	char *str;		//param_str.

	__int64 val;	//param_value
	DWORD retc;		//intmath_retcode
} PARAMLIST;


//-----------------------------------------------------------------------------
//---= include =---------------------------------------------------------------
//-----------------------------------------------------------------------------
#include "lists.h"
#include "errors.h"
#include "intmath.h"


//-----------------------------------------------------------------------------
//---= class =-----------------------------------------------------------------
//-----------------------------------------------------------------------------
class PARAM
{
public:
	PARAM(WORD);
	DWORD scan(char *);
	~PARAM();

	LIST *ParamList;
	WORD flags;
	WORD scan_cntr;

private:
	DWORD add(char *);
};

//-----------------------------------------------------------------------------
//---= extern =----------------------------------------------------------------
//-----------------------------------------------------------------------------
#endif
