#ifndef _DIRECTIVES_
#define _DIRECTIVES_


//-----------------------------------------------------------------------------
//---= include =---------------------------------------------------------------
//-----------------------------------------------------------------------------
#include "includes.h"

#include "lists.h"
#include "errors.h"


//-----------------------------------------------------------------------------
//---= enum/define =-----------------------------------------------------------
//-----------------------------------------------------------------------------

enum
{
	D_MESSAGE, D_ERROR,
	D_COMMENT,
	D_RADIX,
	D_WARN, D_NOWARN,
	D_TARGET,
	D_ASSIGN,
	D_STACK, D_BSS,
	D_END,

	D_R3000, D_R5900,

	D_IF, D_ELSE, D_ENDIF,
	D_ORG, D_ALIGN, D_ALIGN$, D_ALIGN$$,
	D_INCLUDE,
	D_UNDEF, D_DEFINE, D_REGDEF,

	/////////////////////////////////////

	D_DB, D_DH, D_DW, D_DD, D_DQ,

	D_MACRO, D_ENDM,
	D_TABLE, D_ENDT,
	D_PROC, D_ENDP,
	D_SEGMENT, D_ENDS,
  D_VPUCODE, D_ENDVPU,

	D_EQU,

	_D_LAST
};

//#define DIRECTIVES		D_ENDS+1	//number directives with form: {<name>} <D> <param>
//#define DIRECTIVES_SUCC	D_REGDEF+1	//number directives with form: <D> <param>

extern const char *directive_tbl[_D_LAST];

//-----------------------------------------------------------------------------
//---= class =-----------------------------------------------------------------
//-----------------------------------------------------------------------------
class DIRECTIVE
{
public:
	DWORD exec(char *, char *, char *);
	BOOL if_exist(char *);

protected:
	DWORD do_msg(char *, BOOL);
	DWORD do_comment(char *);
	DWORD do_set_radix(char *);
	DWORD do_set_warnlevel(char *, BOOL);
	DWORD do_sel_target(char *);
	DWORD do_assign(char *);
	DWORD do_stack_bss(char *, char);
	DWORD do_eof(char *);
	DWORD do_if(char *);
	DWORD do_org(char *);
	DWORD do_align(char *, BOOL = false);
	BOOL  stream_file_out(void);
	DWORD do_include(char *);
	DWORD do_undef(char *);
	DWORD do_define(char *, BYTE);
	DWORD do_equ(char *, char *);
	DWORD do_dup(char *, int);
	DWORD do_data(char *, char *, int);
	DWORD do_seg(char *, char *);
	DWORD do_class(char *, char *, char);
	DWORD do_end(char *, char *, char);
  DWORD do_vpucode(char *lbl, char *args);
  DWORD do_endvpu(char *lbl, char *args);

	DWORD process_directive(char *, int, char *);
};


//-----------------------------------------------------------------------------
//---= extern =----------------------------------------------------------------
//-----------------------------------------------------------------------------
extern DIRECTIVE directive;
#endif
