#ifndef _INCLUDES_
#define _INCLUDES_

#if defined(UNIX)

    // global gnu definitions

    typedef unsigned int DWORD;
    typedef unsigned short WORD;
    typedef unsigned char BYTE;
    typedef int BOOL;

    #ifndef _GNU_SOURCE
    #define _GNU_SOURCE
    #endif
    #include <sys/types.h>
    #include <stdlib.h>
    #include <ctype.h>
    #include <stdio.h>
    #include <string.h>
    #include <sys/time.h>
    #include <unistd.h>
    #include <iostream>
    #include <fstream>

    #define _strlwr(foo) { char *i = foo; while (*i) *i = tolower(*i), i++; }
    #define strnicmp strncasecmp
    #define stricmp strcasecmp
    #define _stricmp strcasecmp
    #define _strnicmp strncasecmp
    #define _fcloseall fcloseall

#elif defined(__MINGW32__)

    // global mingw32/gcc definitions

    #define WIN32_LEAN_AND_MEAN
    #include <windows.h>
    #include <sys/types.h>
    #include <stdlib.h>
    #include <ctype.h>
    #include <stdio.h>
    #include <string.h>
    #include <sys/time.h>
    #include <unistd.h>
    #include <iostream>
    #include <fstream>

    #undef DWORD
    #define DWORD unsigned int

    #define _fcloseall() ((void)0)

#else

    // global vc++ definitions

    #define WIN32_LEAN_AND_MEAN
    #include <windows.h>
    #include <stdio.h>
    #include <conio.h>
    #include <iostream>

    #pragma warning(disable:4995)   //avoid shitty warnings from micro$oft
    #include <fstream.h>            //telling us we should use <fstream> instead
    #pragma warning(default:4995)   //but then we would have errorlist cooking over

    typedef ULONGLONG __uint64;
    typedef unsigned int __uint32;

#endif


#if defined(__GNUC__)
    using namespace std;

    #if !defined(__int64)
    __extension__ typedef long long __int64;
    #endif
    #if !defined(__uint64)
    __extension__ typedef unsigned long long __uint64;
    #endif
    typedef int __int32;
    typedef unsigned int __uint32;
    typedef short __int16;
    typedef signed char __int8;

    #undef NULL
    #define NULL 0
#endif


#ifdef _DEBUG               // if DEBUG defined then support a debug stream
	extern fstream fdbg;
	#define dbgout(txt)     /*if(fdbg.is_open()) fdbg << txt;*/
	#define dbgout2(txt)    /*if(fdbg.is_open()) fdbg << txt;*/
#else
	#define dbgout(txt)
	#define dbgout2(txt)
#endif
#endif
