#ifndef _INSTRUCTIONS_
#define _INSTRUCTIONS_


//-----------------------------------------------------------------------------
//---= include =---------------------------------------------------------------
//-----------------------------------------------------------------------------
#include "includes.h"

#include "lists.h"
#include "errors.h"
#include "params.h"


//-----------------------------------------------------------------------------
//---= enum/define =-----------------------------------------------------------
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//---= class =-----------------------------------------------------------------
//-----------------------------------------------------------------------------
class INSTRUCTION
{
public:
	DWORD exec(char *, char *);			//execute instruction
	BOOL if_exist(char *);

private:
	DWORD get_reg(PARAMLIST *);
	DWORD get_v32(PARAMLIST *);
	DWORD get_imm(PARAMLIST *);
	DWORD get_inv(PARAMLIST *);
	DWORD get_off(PARAMLIST *);
	DWORD get_nobase(PARAMLIST *);
	DWORD get_off_base(PARAMLIST *, PARAMLIST *);
	DWORD process_instr(int, LIST *);		//write opcode 4 instr.

};


//-----------------------------------------------------------------------------
//---= extern =----------------------------------------------------------------
//-----------------------------------------------------------------------------
extern INSTRUCTION instruction;
#endif
